/***************************************************/
/* Copyright (C) 1999 Yoneji Seto */
/* nittei ץ*/

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <signal.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/AsciiText.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Command.h>
#include "nittei.h"

#define MAX_BUFF 2000

extern Display *dsp;
extern Widget top;

char edit_fname[512];
Widget edit_widget, top2=NULL;

static void edit_close_cb(Widget w, XtPointer w1, XtPointer w2);
static int time_chk_sub(char *buff, int ji, int fun);
static void yotei_disp(char *buff);
static void yotei_close_cb(Widget w, XtPointer w1, XtPointer w2);
static void au_play(void);
static void exec_chk(char *buff);

/** ǥå ********************************************/
/**                                                       **/
void edit_disp(int yy, int mm, int dd)
{
  static Atom wm_delete_window;
  
  Arg arglist[10];
  Widget paned, paned1, btn;

  top2=XtVaCreatePopupShell("edit_window", topLevelShellWidgetClass, top, NULL);
  XtOverrideTranslations(top2, XtParseTranslationTable ("<Message>WM_PROTOCOLS: edit_close()"));

  paned = XtVaCreateManagedWidget("edit_paned", panedWidgetClass, top2, NULL);
  btn=XtVaCreateManagedWidget("edit_close", commandWidgetClass, paned, NULL);
  paned1 = XtVaCreateManagedWidget("edit_paned1", panedWidgetClass, paned, NULL);
  XtAddCallback(btn, XtNcallback, edit_close_cb, NULL);

  XtSetArg(arglist[0], XtNeditType, XawtextEdit);
  XtSetArg(arglist[1], XtNtype, XawAsciiFile);  
  sprintf(edit_fname, "nit%04d%02d%02d", yy, mm, dd);
  if (access(edit_fname, F_OK) != 0)
    creat(edit_fname, 0600);
  XtSetArg(arglist[2], XtNstring, edit_fname);
  edit_widget=XtCreateManagedWidget("edit_view", asciiTextWidgetClass, paned1, arglist, 3);
  XtRealizeWidget(top2);
  XtPopup(top2, XtGrabNone);

  wm_delete_window = XInternAtom(XtDisplay(top2), "WM_DELETE_WINDOW", False);
  XSetWMProtocols (XtDisplay(top2), XtWindow(top2), &wm_delete_window, 1);
}

/**  ܥ *****************************************/
/**                                                       **/
void edit_close_cb(Widget w, XtPointer w1, XtPointer w2)
{
  data_save();
  XtDestroyWidget(top2);
  top2=NULL;
}

/**  ************************************************/
/**                                                       **/
void edit_close()
{
  data_save();
  XtDestroyWidget(top2);
  top2=NULL;
}

/** ѹ ************************************************/
/**                                                       **/
void edit_dat_chg(int yy, int mm, int dd)
{
  Arg arglist[10];

  if (top2)
    XawAsciiSaveAsFile(XawTextGetSource(edit_widget), edit_fname); /*ߤ¸*/
  else
    edit_disp(yy, mm, dd);
    
  sprintf(edit_fname, "nit%04d%02d%02d", yy, mm, dd);
  if (access(edit_fname, F_OK) != 0)
    creat(edit_fname, 0600);
  XtSetArg(arglist[0], XtNstring, edit_fname);                   /*դɤ߹*/
  XtSetValues(edit_widget, arglist, 1);
}

/** ָ ************************************************/
/**                                                       **/
void time_chk(int yy, int mm, int dd, int ji, int fun, int byou)
{
  FILE *fp;
  char buff[MAX_BUFF], fname[100], disp_buff[MAX_BUFF*200];
  int  cnt, y_no;

  if (top2)
    XawAsciiSaveAsFile(XawTextGetSource(edit_widget), edit_fname); /*ߤ¸*/

  cnt=0;
  disp_buff[0]='\0';

  /***򸡺***/
  sprintf(fname, "nit%04d%02d%02d", yy, mm, dd);
  if (NULL==(fp=fopen(fname, "r")))
    return;
  while (NULL!=fgets(buff, MAX_BUFF, fp)){    
    if (time_chk_sub(buff, ji, fun)){
      if (strlen(disp_buff)+strlen(buff)+2 < sizeof(disp_buff))
	strncat(disp_buff, buff, sizeof(disp_buff));
      cnt++;
    }  
  }
  fclose(fp);  

  /***η֤򸡺***/
  if (NULL==(fp=fopen(D_DATA_FILE, "r")))
    return;
  while (NULL!=fgets(buff, MAX_BUFF, fp)){    
    if (time_chk_sub(buff, ji, fun)){
      if (strlen(disp_buff)+strlen(buff)+2 < sizeof(disp_buff))
        strncat(disp_buff, buff, sizeof(disp_buff));
      cnt++;
    }  
  }
  fclose(fp);  

  /***轵,Ʊͽ򸡺***/
  y_no=youbi_cal(yy, mm, dd);
  sprintf(fname, "%s-%d", W_DATA_FILE, y_no);
  if (NULL==(fp=fopen(fname, "r")))
    return;
  while (NULL!=fgets(buff, MAX_BUFF, fp)){    
    if (time_chk_sub(buff, ji, fun)){
      if (strlen(disp_buff)+strlen(buff)+2 < sizeof(disp_buff))
        strncat(disp_buff, buff, sizeof(disp_buff));
      cnt++;
    }  
  }
  fclose(fp);  

  /***,Ʊͽ򸡺***/
  sprintf(fname, "%s-%d", M_DATA_FILE, dd);
  if (NULL==(fp=fopen(fname, "r")))
    return;
  while (NULL!=fgets(buff, MAX_BUFF, fp)){    
    if (time_chk_sub(buff, ji, fun)){
      if (strlen(disp_buff)+strlen(buff)+2 < sizeof(disp_buff))
        strncat(disp_buff, buff, sizeof(disp_buff));
      cnt++;
    }  
  }
  fclose(fp);  

  if (cnt){
    XBell(dsp, 0);
    yotei_disp(disp_buff);
    signal(SIGCHLD, SIG_IGN);
    if (0==fork()){
      au_play();
      exit(0);
    }  
  }

}

/** au *********************************************/
/** fork ץ                                         **/
void au_play(void)
{
  FILE *fp1, *fp2;
  int ch;

  if (NULL==(fp1=fopen("nittei.au", "r")))
    return;

  if (NULL==(fp2=fopen("/dev/audio", "w"))){
    fclose(fp1);
    return;
  }

  while(EOF!=(ch=fgetc(fp1)))
    fputc(ch, fp2);

  fclose(fp1);
  fclose(fp2);
}

/** ()ιʸ򸡺 **************************************/
/** ret 1=֤ 0=ޤ                              **/
int time_chk_sub(char *buff, int ji, int fun)
{
  int hh, mm, delta, np;
  char wk[10];

  memset(wk, 0, 10);
  np=0;
  if (buff[0]=='('){
    if (buff[3]==':'){
      if (buff[6]==')'){    /* (00:00) */
	strncpy(wk, buff+1, 2);
	hh=atoi(wk);
	memset(wk, 0, 10);
	strncpy(wk, buff+4, 2);
	mm=atoi(wk);
	np=7;
      }else if (buff[5]==')'){	   /* (00:0) */
	strncpy(wk, buff+1, 2);
	hh=atoi(wk);
	memset(wk, 0, 10);
	strncpy(wk, buff+4, 1);
	mm=atoi(wk);
	np=6;
      }
    }else if (buff[2]==':'){
      if (buff[5]==')'){    /* (0:00) */
	strncpy(wk, buff+1, 1);
	hh=atoi(wk);
	memset(wk, 0, 10);
	strncpy(wk, buff+3, 2);
	mm=atoi(wk);
	np=6;
      }else if (buff[4]==')'){    /* (0:0) */
	strncpy(wk, buff+1, 1);
	hh=atoi(wk);
	memset(wk, 0, 10);
	strncpy(wk, buff+3, 1);
	mm=atoi(wk);
	np=5;
      }	
    }
  }
  
  memset(wk, 0, 10);
  delta=0;
  if (np){
    if (buff[np]=='('){
      if (buff[np+3]==')'){          /* (00) */
	strncpy(wk, buff+np+1, 2);
	delta=atoi(wk);
      }else if (buff[np+2]==')'){         /* (0) */
	strncpy(wk, buff+np+1, 1);
	delta=atoi(wk);
      }
    }
  }

  if (mm < delta){         /*00ʬۤ*/
    mm=60-(delta-mm);
    hh--;
  }else
   mm -= delta; 

  if (hh == ji && mm == fun){
    exec_chk(buff);
    return 1;
  }  

  return 0;
}

/** ¹Ը ************************************************/
/**                                                       **/
void exec_chk(char *buff)
{
  char *argv[10];
  char *pch;

  if (NULL==(pch=strstr(buff, ")exec=")))
    return;
  pch+=6;
  
  if (0==fork()){
    argv[0]="/bin/sh";
    argv[1]="-c";
    argv[2]=pch;
    execvp(argv[0], argv);
    exit(0);
  }
}  
  

/** ͽɽ *** ********************************************/
/**                                                       **/
void yotei_disp(char *buff)
{
  static Atom wm_delete_window;

  Arg arglist[10];
  Widget paned, paned1, btn, yotei_top;

  yotei_top=XtVaCreatePopupShell("yotei_window", topLevelShellWidgetClass, top, NULL);
  XtOverrideTranslations(yotei_top, XtParseTranslationTable ("<Message>WM_PROTOCOLS: yotei_close()"));

  paned = XtVaCreateManagedWidget("yotei_paned", panedWidgetClass, yotei_top, NULL);
  btn=XtVaCreateManagedWidget("yotei_close", commandWidgetClass, paned, NULL);
  paned1 = XtVaCreateManagedWidget("yotei_paned1", panedWidgetClass, paned, NULL);
  XtAddCallback(btn, XtNcallback, yotei_close_cb, (XtPointer)yotei_top);

  XtSetArg(arglist[0], XtNeditType, XawtextRead);
  XtSetArg(arglist[1], XtNstring, buff);  
  XtCreateManagedWidget("yotei_view", asciiTextWidgetClass, paned1, arglist, 2);

  XtRealizeWidget(yotei_top);
  XtPopup(yotei_top, XtGrabNone);

  wm_delete_window = XInternAtom(XtDisplay(yotei_top), "WM_DELETE_WINDOW", False);
  XSetWMProtocols (XtDisplay(yotei_top), XtWindow(yotei_top), &wm_delete_window, 1);
}

/** ͽɽ  ܥ *********************************/
/**                                                       **/
void yotei_close_cb(Widget w, XtPointer w1, XtPointer w2)
{
  XtDestroyWidget((Widget)w1);
}

/** ͽɽ  ****************************************/
/**                                                       **/
void yotei_close(Widget w)
{
  XtDestroyWidget(w);
}

/***********************************************************/
/**                                                       **/
void data_save(void)
{
   Arg arglist[10];

  if (top2){
    XawAsciiSaveAsFile(XawTextGetSource(edit_widget), edit_fname); /*ߤ¸*/
    XtSetArg(arglist[0], XtNstring, edit_fname);                   /*դɤ߹*/
    XtSetValues(edit_widget, arglist, 1);
  }  
}
