/***************************************************/
/* Copyright (C) 1999 Yoneji Seto */
/* nittei ץ*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <signal.h>
#include <unistd.h>
#include <sys/types.h>
#include <fcntl.h>
#include <dirent.h>
#include <sys/dir.h>
#include <sys/stat.h>
#include <sys/time.h>

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/AsciiText.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Command.h>
#include "nittei.h"

extern Display *dsp;
extern Widget top, top2, edit_widget;
extern char *edit_fname;
extern int m_max[13];
extern int h_day_max;
extern H_DAY h_day[365];

static int h_day_chk(int yy, int mm, int dd, char *h_name, int *furikae);
static void temp_create(int yy, int mm, int dd);

#define HTML_TEMP_FILE "HTML/temp_file"

/** ͽɽ html *****************************************/
/**                                                       **/
void html_create(int yy, int mm, int dd)
{
  static char *youbi[7]={"","ʷ","ʲС","ʿ","ڡ","ʶ","ڡ"};

  char ofname[50], mmdd[50], title[50], wk[H_NAME_MAX+50], h_name[H_NAME_MAX];
  FILE *fp, *ofp;
  int i, b, n, yno, h_fg, h_furikae;
  int furikae, ch;

  data_save();

  h_furikae=0;
  sprintf(ofname, "HTML/nit%04d%02d.html", yy, mm);
  if (NULL==(ofp=fopen(ofname, "w")))
    return;
  fputs("<HTML>\n", ofp);
  fputs("<HEAD>\n", ofp);

  /* Style File Setting */
  fputs("<style TYPE='text/css'>", ofp);
  fputs("<!--\n", ofp);
  fputs("BODY { font-size: small; }\n", ofp);
  fputs("TH { font-size: small; }\n", ofp);
  fputs("TD { font-size: small; }\n", ofp);
  fputs("-->\n", ofp);
  fputs("</style>\n", ofp);
  fputs("<title>\n", ofp);
  fputs("</title>\n", ofp);
  fputs("<meta http-equiv='Content-Type' content='text/html; charset=EUC-JP'>\n", ofp);

  fputs("</HEAD>\n", ofp);

  fputs("<BODY text=black bgcolor=white>\n", ofp);
  sprintf(title, "<CENTER><H3>%4dǯ%02d ͽɽ</H3></CENTER>", yy, mm);
  fputs(title, ofp);
  fputs("<TABLE ALIGN=CENTER BORDER>\n", ofp);

  for (i=1; i<=m_max[mm]; i++){
    temp_create(yy, mm, i);
    yno=youbi_cal(yy, mm, i);
    sprintf(mmdd, "%2d%s<BR>", i, youbi[yno]);
     
    fputs("<TR>\n", ofp);
    h_fg=h_day_chk(yy, mm, i, h_name, &furikae);

    if (0==yno || h_fg || h_furikae)
      fputs("<TD NOWRAP BGCOLOR=\"#FF5555\">", ofp);
    else {
      if ( 6==yno )
        fputs("<TD NOWRAP BGCOLOR=\"#5555FF\">", ofp);
      else
        fputs("<TD NOWRAP>", ofp);
    }
    fputs(mmdd, ofp);
    if (h_fg){                           /*̾*/
      sprintf(wk, "%s<BR>", h_name);
      fputs(wk, ofp);
    }
    if (h_furikae)                      /*ص*/
      fputs("ص<BR>", ofp);

    if (0==yno && h_fg && furikae)      /*صϿ*/
      h_furikae=1;
    else
      h_furikae=0;

    fputs("</TD>\n", ofp);
    fputs("<TD>\n", ofp);
    if (NULL==(fp=fopen(HTML_TEMP_FILE, "r")))
      fputs("<BR>\n", ofp);
    else{
      b=0;
      n=0;
      while(EOF!=(ch=fgetc(fp))){
	if (ch=='\n'){
	  fputs("<BR>\n", ofp);
	  n=-1; b=0;
	}else if (ch=='(' && 0==n){
	  b=1;
	}else if (ch==')' && b){
	  fputs("ʬ", ofp);
	  b=0;
	}else if (ch==':' && b){
	  fputs("", ofp);
	}else
	  putc(ch, ofp);
	n++;
      }
      fclose(fp);
    }  
    fputs("</TD>\n", ofp);
    fputs("</TR>\n", ofp);
  }  

  fputs("</TABLE>\n", ofp);
  fputs("</BODY>\n", ofp);
  fputs("</HTML>\n", ofp);
 
  fclose(ofp);
}

/**  *********************************************/
/** ret 1= 0=ʿ                                   **/
int h_day_chk(int yy, int mm, int dd, char *h_name, int *furikae)
{
  int j;

  for (j=0; j<h_day_max; j++){
    if (0 == h_day[j].yy || yy == h_day[j].yy){
      if (mm == h_day[j].mm && dd == h_day[j].dd){
	strncpy(h_name, h_day[j].name, H_NAME_MAX);
        *furikae=h_day[j].furikae;
	return 1;
      }	
    }
  }

  return 0;
}

/** ƥݥ꡼˷ ***************************************/
/**                                                       **/
void temp_create(int yy, int mm, int dd)
{
  FILE *fp, *ofp;
  char fname[100];
  int  y_no, ch;
  struct stat st;

  if (NULL==(ofp=fopen(HTML_TEMP_FILE, "w")))
    return;

  /******/
  sprintf(fname, "nit%04d%02d%02d", yy, mm, dd);
  stat(fname, &st);
  if (NULL!=(fp=fopen(fname, "r"))){
    while (EOF!=(ch=fgetc(fp)))
      putc(ch, ofp);
    fclose(fp);  
  }

  /***η֤***/
  stat(D_DATA_FILE, &st);
  if (st.st_size){
    fputs("\n----\n", ofp);
    if (NULL!=(fp=fopen(D_DATA_FILE, "r"))){
      while (EOF!=(ch=fgetc(fp)))
	putc(ch, ofp);
      fclose(fp);  
    }
  }  

  /***轵,Ʊͽ***/
  y_no=youbi_cal(yy, mm, dd);
  sprintf(fname, "%s-%d", W_DATA_FILE, y_no);
  stat(fname, &st);
  if (st.st_size){
    fputs("\n--轵--\n", ofp);
    if (NULL!=(fp=fopen(fname, "r"))){
      while (EOF!=(ch=fgetc(fp)))
	putc(ch, ofp);
      fclose(fp);  
    }
  }

  /***,Ʊͽ***/
  sprintf(fname, "%s-%d", M_DATA_FILE, dd);
  stat(fname, &st);
  if (st.st_size){
    fputs("\n----\n", ofp);
    if (NULL!=(fp=fopen(fname, "r"))){
      while (EOF!=(ch=fgetc(fp)))
	putc(ch, ofp);
      fclose(fp);  
    }
  }

  fclose(ofp);
}
