/***************************************************/
/* Copyright (C) 1999 Yoneji Seto */
/* nittei ץ*/

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <signal.h>
#include <unistd.h> 
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/AsciiText.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Command.h>
#include "nittei.h"

extern Display *dsp;
extern Widget top;
extern int  yy_save, mm_save, dd_save, max_no;

static void menu_close_cb(Widget w, XtPointer w1, XtPointer w2);
static void zen_nen_cb();
static void rai_nen_cb();
static void zen_nen5_cb();
static void rai_nen5_cb();
static void tuki_yotei_hyou_cb();
static void d_data_cb();
static void w_data_cb();
static void m_data_cb();
static void sach_cb();
static void ichiran_cb();

static Widget menu_top=NULL;

/** ˥塼 ********************************************/
/**                                                   **/
void menu_disp_cd()
{
  static Atom wm_delete_window;

  Widget form, btn;

  if (menu_top)
    return;

  menu_top=XtVaCreatePopupShell("menu_window", topLevelShellWidgetClass, top, NULL);
  XtOverrideTranslations(menu_top, XtParseTranslationTable ("<Message>WM_PROTOCOLS: menu_close()"));

  form=  XtVaCreateManagedWidget("menu_form", formWidgetClass, menu_top, NULL);

  btn=XtVaCreateManagedWidget("zen_nen", commandWidgetClass, form, NULL);
  XtAddCallback(btn, XtNcallback, zen_nen_cb, NULL);
  btn=XtVaCreateManagedWidget("rai_nen", commandWidgetClass, form, NULL);
  XtAddCallback(btn, XtNcallback, rai_nen_cb, NULL);
  btn=XtVaCreateManagedWidget("zen_nen5", commandWidgetClass, form, NULL);
  XtAddCallback(btn, XtNcallback, zen_nen5_cb, NULL);
  btn=XtVaCreateManagedWidget("rai_nen5", commandWidgetClass, form, NULL);
  XtAddCallback(btn, XtNcallback, rai_nen5_cb, NULL);

  btn=XtVaCreateManagedWidget("d_data", commandWidgetClass, form, NULL);
  XtAddCallback(btn, XtNcallback, d_data_cb, NULL);
  btn=XtVaCreateManagedWidget("w_data", commandWidgetClass, form, NULL);
  XtAddCallback(btn, XtNcallback, w_data_cb, NULL);
  btn=XtVaCreateManagedWidget("m_data", commandWidgetClass, form, NULL);
  XtAddCallback(btn, XtNcallback, m_data_cb, NULL);

  btn=XtVaCreateManagedWidget("sach_btn", commandWidgetClass, form, NULL);
  XtAddCallback(btn, XtNcallback, sach_cb, NULL);

  btn=XtVaCreateManagedWidget("ichiran_btn", commandWidgetClass, form, NULL);
  XtAddCallback(btn, XtNcallback, ichiran_cb, NULL);

  btn=XtVaCreateManagedWidget("tuki_yotei_hyou", commandWidgetClass, form, NULL);
  XtAddCallback(btn, XtNcallback, tuki_yotei_hyou_cb, NULL);
  btn=XtVaCreateManagedWidget("menu_quit", commandWidgetClass, form, NULL);
  XtAddCallback(btn, XtNcallback, quit_cb, NULL);
  btn=XtVaCreateManagedWidget("menu_close", commandWidgetClass, form, NULL);
  XtAddCallback(btn, XtNcallback, menu_close_cb, menu_top);

  XtRealizeWidget(menu_top);
  XtPopup(menu_top, XtGrabNone);

  wm_delete_window = XInternAtom(XtDisplay(menu_top), "WM_DELETE_WINDOW", False);
  XSetWMProtocols (XtDisplay(menu_top), XtWindow(menu_top), &wm_delete_window, 1);
}

/** ˥塼  ܥ *********************************/
/**                                                       **/
void menu_close_cb(Widget w, XtPointer w1, XtPointer w2)
{
  XtDestroyWidget((Widget)w1);
  menu_top=NULL;
}

/** ˥塼  ****************************************/
/**                                                       **/
void menu_close(Widget w)
{
  XtDestroyWidget(w);
  menu_top=NULL;
}

/** λ ***************************************************/
/**                                                       **/
void quit_cb()
{
  data_save();
  exit(0); 
}

/** ǯ 5 **************************************************/
/**                                                       **/
void zen_nen5_cb()
{
  yy_save -= 5;
  if (1 > yy_save)
    yy_save=1;
  day_disp_chg();
}

/** ǯ 5 **************************************************/
/**                                                       **/
void rai_nen5_cb()
{
  yy_save += 5;
  day_disp_chg();
}

/** ͽ *************************************************/
/**                                                       **/
void d_data_cb()
{
  d_disp();
}

/** 轵ͽ *************************************************/
/**                                                       **/
void w_data_cb()
{
  w_disp();
}

/** ͽ *************************************************/
/**                                                       **/
void m_data_cb()
{
  m_disp();
}

/** ͽ ************************************************/
/**                                                       **/
void sach_cb()
{
  s_disp();
}

/** Ĥͽ ********************************************/
/**                                                       **/
void ichiran_cb()
{
  ichiran_disp(yy_save, mm_save, dd_save);
}

/** html ͽɽ *******************************************/
/**                                                       **/
void tuki_yotei_hyou_cb()
{
  html_create(yy_save, mm_save, dd_save);
}

/** ǯ ***************************************************/
/**                                                       **/
void zen_nen_cb()
{
  yy_save--;
  if (1 > yy_save)
    yy_save=1;
  day_disp_chg();
}

/** ǯ ***************************************************/
/**                                                       **/
void rai_nen_cb()
{
  yy_save++;
  day_disp_chg();
}

