/***************************************************/
/* Copyright (C) 1999 Yoneji Seto */
/* nittei ץ*/

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <signal.h>
#include <unistd.h> 
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/AsciiText.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Command.h>
#include "nittei.h"

extern Display *dsp;
extern Widget top;
extern int  yy_save, mm_save, dd_save, max_no;

static Widget d_widget, w_widget, m_widget;
static void d_close_cb(Widget w, XtPointer w1, XtPointer w2);
static void w_close_cb(Widget w, XtPointer w1, XtPointer w2);
static void m_close_cb(Widget w, XtPointer w1, XtPointer w2);
static void w_btn_cb(Widget w, XtPointer w1, XtPointer w2);
static void w_btn_color(void);
static void w_save();
static void m_save();
static void m_btn_create(Widget paned0);
static void m_btn_cb(Widget w, XtPointer w1, XtPointer w2);
static void m_btn_color(void);

static Widget d_top=NULL, w_top=NULL, m_top=NULL;
static int w_no=0;
static Widget w_btn[7];

/** ͽ ************************************************/
/**                                                       **/
void d_disp(void)
{
  static Atom wm_delete_window;

  Arg arglist[10];
  Widget paned, paned1, btn;

  if (d_top)
    return;

  d_top=XtVaCreatePopupShell("d_window", topLevelShellWidgetClass, top, NULL);
  XtOverrideTranslations(d_top, XtParseTranslationTable ("<Message>WM_PROTOCOLS: d_close()"));

  paned = XtVaCreateManagedWidget("d_top_paned", panedWidgetClass, d_top, NULL);
  btn=XtVaCreateManagedWidget("d_close", commandWidgetClass, paned, NULL);
  paned1 = XtVaCreateManagedWidget("d_top_paned1", panedWidgetClass, paned, NULL);
  XtAddCallback(btn, XtNcallback, d_close_cb, (XtPointer)d_top);

  XtSetArg(arglist[0], XtNeditType, XawtextEdit);
  XtSetArg(arglist[1], XtNtype, XawAsciiFile);  
  XtSetArg(arglist[2], XtNstring, D_DATA_FILE);  
  d_widget=XtCreateManagedWidget("d_edit", asciiTextWidgetClass, paned1, arglist, 3);

  XtRealizeWidget(d_top);
  XtPopup(d_top, XtGrabNone);

  wm_delete_window = XInternAtom(XtDisplay(d_top), "WM_DELETE_WINDOW", False);
  XSetWMProtocols (XtDisplay(d_top), XtWindow(d_top), &wm_delete_window, 1);
}

/** ͽ  ܥ *********************************/
/**                                                       **/
void d_close_cb(Widget w, XtPointer w1, XtPointer w2)
{
  XawAsciiSaveAsFile(XawTextGetSource(d_widget), D_DATA_FILE); /*¸*/
  XtDestroyWidget((Widget)w1);
  d_top=NULL;
}

/** ɽ  ****************************************/
/**                                                       **/
void d_close(Widget w)
{
  XawAsciiSaveAsFile(XawTextGetSource(d_widget), D_DATA_FILE); /*¸*/
  XtDestroyWidget(w);
  d_top=NULL;
}

/** 轵ͽ ************************************************/
/**                                                       **/
void w_disp(void)
{
  static Atom wm_delete_window;

  Arg arglist[10];
  Widget paned0, paned1, panedw, form, btn;
  int i;
  char fname[256], bname[256];

  if (w_top)
    return;

  w_no=youbi_cal(yy_save, mm_save, dd_save);    /*Ϥ*/
  w_top=XtVaCreatePopupShell("w_window", topLevelShellWidgetClass, top, NULL);
  XtOverrideTranslations(w_top, XtParseTranslationTable ("<Message>WM_PROTOCOLS: w_close()"));

  paned0 = XtVaCreateManagedWidget("w_top_paned0", panedWidgetClass, w_top, NULL);
  panedw = XtVaCreateManagedWidget("w_top_panedw", panedWidgetClass, paned0, NULL);
  paned1 = XtVaCreateManagedWidget("w_top_paned1", panedWidgetClass, paned0, NULL);

  form=  XtVaCreateManagedWidget("w_btn_form", formWidgetClass, panedw, NULL);
  for (i=0; i<7; i++){
    sprintf(bname, "yname%d", i);
    w_btn[i]=XtVaCreateManagedWidget(bname, commandWidgetClass, form, NULL);
    XtAddCallback(w_btn[i], XtNcallback, w_btn_cb, (XtPointer)i);
  }
  w_btn_color();

  btn=XtVaCreateManagedWidget("w_close", commandWidgetClass, form, NULL);
  XtAddCallback(btn, XtNcallback, w_close_cb, (XtPointer)w_top);

  XtSetArg(arglist[0], XtNeditType, XawtextEdit);
  XtSetArg(arglist[1], XtNtype, XawAsciiFile);  
  sprintf(fname, "%s-%d", W_DATA_FILE, w_no);
  XtSetArg(arglist[2], XtNstring, fname);  
  w_widget=XtCreateManagedWidget("w_edit", asciiTextWidgetClass, paned1, arglist, 3);

  XtRealizeWidget(w_top);
  XtPopup(w_top, XtGrabNone);

  wm_delete_window = XInternAtom(XtDisplay(w_top), "WM_DELETE_WINDOW", False);
  XSetWMProtocols (XtDisplay(w_top), XtWindow(w_top), &wm_delete_window, 1);
}

/** 轵ͽ ܥ  ***************************************/
/**                                                       **/
void w_btn_color(void)
{
  Arg arglist[10];
  XtArgVal bg;
  XColor green, xcw;
  Colormap cm;
  int i;

  XtVaGetValues(top, XtNbackground, &bg, NULL);
  cm=DefaultColormap(dsp, 0);
  XAllocNamedColor(dsp, cm, "green", &green, &xcw);
  
  for (i=0; i<7; i++){
    XtSetArg(arglist[0], XtNbackground, bg);
    XtSetValues(w_btn[i], arglist, 1);
  }

  XtSetArg(arglist[0], XtNbackground,  green.pixel);
  XtSetValues(w_btn[w_no], arglist, 1);
}

/** 轵ͽ  ܥ *********************************/
/**                                                       **/
void w_close_cb(Widget w, XtPointer w1, XtPointer w2)
{
  w_save();
  XtDestroyWidget((Widget)w1);
  w_top=NULL;
}

/** 轵ɽ  ****************************************/
/**                                                       **/
void w_close(Widget w)
{
  w_save();
  XtDestroyWidget(w);
  w_top=NULL;
}

/** 轵ܥCB ********************************************/
/**                                                       **/
void w_btn_cb(Widget w,  XtPointer w1, XtPointer w2)
{
  Arg arglist[10];
  char bfname[256];

  w_save();

  w_no=(int)w1;
  w_btn_color();

  sprintf(bfname, "%s-%d", W_DATA_FILE, w_no);
  XtSetArg(arglist[0], XtNstring, bfname);                   /*ɤ߹*/
  XtSetValues(w_widget, arglist, 1);
}

/** 轵ͽ ¸ *******************************************/
/**                                                       **/
void w_save()
{
  char fname[256];

  sprintf(fname, "%s-%d", W_DATA_FILE, w_no);
  XawAsciiSaveAsFile(XawTextGetSource(w_widget), fname); /*¸*/
}

/** ͽ ************************************************/
/**                                                       **/
static int m_no=0;
static Widget day_w[32];
void m_disp(void)
{
  static Atom wm_delete_window;

  Arg arglist[10];
  Widget paned0, paned1, panedw;
  char fname[256];

  if (m_top)
    return;

  m_no=dd_save;
  m_top=XtVaCreatePopupShell("m_window", topLevelShellWidgetClass, top, NULL);
  XtOverrideTranslations(m_top, XtParseTranslationTable ("<Message>WM_PROTOCOLS: m_close()"));

  paned0 = XtVaCreateManagedWidget("m_top_paned0", panedWidgetClass, m_top, NULL);
  panedw = XtVaCreateManagedWidget("m_top_panedw", panedWidgetClass, paned0, NULL);
  paned1 = XtVaCreateManagedWidget("m_top_paned1", panedWidgetClass, paned0, NULL);

  m_btn_create(panedw);

  XtSetArg(arglist[0], XtNeditType, XawtextEdit);
  XtSetArg(arglist[1], XtNtype, XawAsciiFile);  
  sprintf(fname, "%s-%d", M_DATA_FILE, m_no);
  XtSetArg(arglist[2], XtNstring, fname);  
  m_widget=XtCreateManagedWidget("m_edit", asciiTextWidgetClass, paned1, arglist, 3);

  m_btn_color();

  XtRealizeWidget(m_top);
  XtPopup(m_top, XtGrabNone);

  wm_delete_window = XInternAtom(XtDisplay(m_top), "WM_DELETE_WINDOW", False);
  XSetWMProtocols (XtDisplay(m_top), XtWindow(m_top), &wm_delete_window, 1);
}

/** ͽ  ܥ *********************************/
/**                                                       **/
void m_close_cb(Widget w, XtPointer w1, XtPointer w2)
{
  m_save();
  XtDestroyWidget((Widget)w1);
  m_top=NULL;
}

/** ɽ  ****************************************/
/**                                                       **/
void m_close(Widget w)
{
  m_save();
  XtDestroyWidget(w);
  m_top=NULL;
}

/** ͽ ¸ *******************************************/
/**                                                       **/
void m_save()
{
  char fname[256];

  sprintf(fname, "%s-%d", M_DATA_FILE, m_no);
  XawAsciiSaveAsFile(XawTextGetSource(m_widget), fname); /*¸*/
}

/** ͽ  ܥ *************************************/
/**                                                       **/
void m_btn_cb(Widget w, XtPointer w1, XtPointer w2)
{
  Arg arglist[10];
  char bfname[256];

  m_save();

  m_no=(int)w1;
  m_btn_color();

  sprintf(bfname, "%s-%d", M_DATA_FILE, m_no);
  XtSetArg(arglist[0], XtNstring, bfname);                   /*ɤ߹*/
  XtSetValues(m_widget, arglist, 1);
}

/** ͽ ܥ  ***************************************/
/**                                                       **/
void m_btn_color(void)
{
  Arg arglist[10];
  XtArgVal bg;
  XColor green, xcw;
  Colormap cm;
  int i;

  XtVaGetValues(top, XtNbackground, &bg, NULL);
  cm=DefaultColormap(dsp, 0);
  XAllocNamedColor(dsp, cm, "green", &green, &xcw);
  
  for (i=1; i<32; i++){
    XtSetArg(arglist[0], XtNbackground, bg);
    XtSetValues(day_w[i], arglist, 1);
  }

  XtSetArg(arglist[0], XtNbackground,  green.pixel);
  XtSetValues(day_w[m_no], arglist, 1);
}

/** եܥ ******************************************/
/**                                                       **/
void m_btn_create(Widget paned0)
{
  Arg arglist[10];
  Widget day_form, btn;
  int    i, j, no;
  char   wname[50], dd[10];

  day_form=  XtVaCreateManagedWidget("m_day_form", formWidgetClass, paned0, NULL);
  XtSetArg(arglist[0], XtNfromVert, NULL);
  XtSetArg(arglist[1], XtNfromHoriz, NULL);
  XtSetArg(arglist[2], XtNmappedWhenManaged, True);
  XtSetArg(arglist[3], XtNlabel, "   ");
  no=1;
  for (i=0; i<16; i++){
    sprintf(wname, "m_day%02d", no);
    sprintf(dd, "%2d", no);
    XtSetArg(arglist[3], XtNlabel, dd);
    day_w[no]=XtCreateManagedWidget(wname, commandWidgetClass, day_form, arglist, 4);
    XtAddCallback(day_w[no], XtNcallback, m_btn_cb, (XtPointer)no);
    XtSetArg(arglist[1], XtNfromHoriz, day_w[no]);
    no++;
  } 

  XtSetArg(arglist[0], XtNfromVert, day_w[no-16]);
  for (j=0; j<15; j++){
    if (j==0)
      XtSetArg(arglist[1], XtNfromHoriz, NULL);
    else
      XtSetArg(arglist[1], XtNfromHoriz, day_w[no-1]);
    sprintf(wname, "m_day%02d", no);
    sprintf(dd, "%2d", no);
    XtSetArg(arglist[3], XtNlabel, dd);
    day_w[no]=XtCreateManagedWidget(wname, commandWidgetClass, day_form, arglist, 4);
    XtAddCallback(day_w[no], XtNcallback, m_btn_cb, (XtPointer)no);
    no++;
  }  
  XtSetArg(arglist[1], XtNfromHoriz, day_w[31]);
  XtSetArg(arglist[3], XtNlabel, "Ĥ");
  btn=XtCreateManagedWidget("w_close", commandWidgetClass, day_form, arglist, 4);
  XtAddCallback(btn, XtNcallback, m_close_cb, (XtPointer)m_top);
}


