/***************************************************/
/* Copyright (C) 1999 Yoneji Seto */
/* nittei ץ*/

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <signal.h>
#include <unistd.h> 
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <dirent.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/AsciiText.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Toggle.h>
#include <X11/Xaw/Viewport.h>
#include <X11/Xaw/List.h>
#include <X11/Xaw/Text.h>
#include <X11/Xaw/Scrollbar.h>
#include "nittei.h"

extern Display *dsp;
extern Widget top;
extern int  yy_save, mm_save, dd_save, max_no;

static Widget s_top=NULL, s_string, list, vport, s_edit;
static int first=1;
static int kikan=1,select_ok=0;

static void s_close_cb(Widget w, XtPointer w1, XtPointer w2);
static void s_tgl_cb(Widget w, XtPointer w1, XtPointer w2);
static void s_kensaku_cb(Widget w, XtPointer w1, XtPointer w2);
static void list_set();
static void s_list_cb(Widget bar, XtPointer argArg, XtPointer itemArg);
static int sort_cmp(char **a, char **b);

/**  ***************************************************/
/**                                                       **/
void s_disp(void)
{
  static Atom wm_delete_window;

  Arg arglist[10];
  Widget form0, form1, form2, form21, form22;
  Widget label1, btn, tgl;

  if (s_top){
    XtPopup(s_top, XtGrabNone);
    return;
  }

  s_top=XtVaCreatePopupShell("s_window", topLevelShellWidgetClass, top, NULL);
  XtOverrideTranslations(s_top, XtParseTranslationTable ("<Message>WM_PROTOCOLS: s_close()"));

  form0 = XtVaCreateManagedWidget("s_form0", formWidgetClass, s_top, NULL);
  form1 = XtVaCreateManagedWidget("s_form1", formWidgetClass, form0, NULL);
  form2 = XtVaCreateManagedWidget("s_form2", formWidgetClass, form0, NULL);
  form21 = XtVaCreateManagedWidget("s_form21", panedWidgetClass, form2, NULL);
  form22 = XtVaCreateManagedWidget("s_form22", panedWidgetClass, form2, NULL);

  label1 = XtVaCreateManagedWidget("s_label1", labelWidgetClass, form1, NULL);
  XtSetArg(arglist[0], XtNeditType, XawtextEdit);
  s_string = XtCreateManagedWidget("s_string", asciiTextWidgetClass, form1, arglist, 1);

  btn=XtVaCreateManagedWidget("s_kensaku", commandWidgetClass, form1, NULL);
  XtAddCallback(btn, XtNcallback, s_kensaku_cb, NULL);

  tgl=XtVaCreateManagedWidget("s_tgl1", toggleWidgetClass, form1, NULL);
  XtAddCallback(tgl, XtNcallback, s_tgl_cb, (XtPointer)1);
  tgl=XtVaCreateManagedWidget("s_tgl2", toggleWidgetClass, form1, NULL);
  XtAddCallback(tgl, XtNcallback, s_tgl_cb, (XtPointer)2);
  tgl=XtVaCreateManagedWidget("s_tgl3", toggleWidgetClass, form1, NULL);
  XtAddCallback(tgl, XtNcallback, s_tgl_cb, (XtPointer)3);
  tgl=XtVaCreateManagedWidget("s_tgl4", toggleWidgetClass, form1, NULL);
  XtAddCallback(tgl, XtNcallback, s_tgl_cb, (XtPointer)4);

  btn=XtVaCreateManagedWidget("s_close", commandWidgetClass, form1, NULL);
  XtAddCallback(btn, XtNcallback, s_close_cb, (XtPointer)s_top);

  XtSetArg(arglist[0], XtNeditType, XawtextEdit);
  s_edit=XtCreateManagedWidget("s_edit", asciiTextWidgetClass, form21, arglist, 1);

  vport = XtVaCreateManagedWidget("s_vport", viewportWidgetClass, form22, NULL);
  list = XtVaCreateManagedWidget("s_list", listWidgetClass, vport, NULL);
  XtAddCallback(list, XtNcallback, s_list_cb, NULL);

  list_set(NULL);

  XtSetKeyboardFocus(form0, s_string);
  XtRealizeWidget(s_top);
  XtPopup(s_top, XtGrabNone);

  wm_delete_window = XInternAtom(XtDisplay(s_top), "WM_DELETE_WINDOW", False);
  XSetWMProtocols (XtDisplay(s_top), XtWindow(s_top), &wm_delete_window, 1);
}

/**  ܥ *****************************************/
/**                                                       **/
void s_close_cb(Widget w, XtPointer w1, XtPointer w2)
{
  XtPopdown(s_top);
}

/** ɽ  *******************************************/
/**                                                       **/
void s_close(Widget w)
{
  XtPopdown(s_top);
}

/**  ܥ *****************************************/
/**                                                       **/
void s_tgl_cb(Widget w, XtPointer w1, XtPointer w2)
{
  kikan=(int)w1;
}

/**  ܥ *****************************************/
/**                                                       **/
void s_kensaku_cb(Widget w, XtPointer w1, XtPointer w2)
{
  String str;

  XtVaGetValues(s_string, XtNstring, &str, NULL);
  if (NULL==str || *str=='\0')
    return;
  
  list_set(str);
}

/** ꥹȥ䡼 ******************************************/
/**                                                       **/
void list_clear(Widget list)
{
  String *strs;
  int i, n;

  if (first){
    first=0;
    return;
  }

  XtVaGetValues(list, XtNnumberStrings, &n, XtNlist, &strs, NULL);
  
  for (i = 0; i < n; i++)
    XtFree((XtPointer) strs[i]);
  XtFree((XtPointer) strs);
}

/** ꥹȥ *******************************************/
/**                                                      **/
int sort_cmp(char **a, char **b)
{
  return strcmp(*a, *b);
}

/** ꥹȥå *********************************************/
/**                                                        **/
#define MAX_BUFF 2000
void list_set(char *ss)
{
  Arg arglist[10];
  Widget sb;
  String *str;
  int i, cnt;
  float top = 0.0; 
  DIR *dir;
  struct dirent *pdire;
  char buff[MAX_BUFF], cs[50], wk[50];
  FILE *fp;
  int yy, mm, dd, ji, fun, byou;

  dir=opendir(".");
  if (NULL==dir)
    return;
  cnt=0;
  pdire=readdir(dir);
  while(pdire){
    if (0 == strncmp(pdire->d_name, "nit", 3))
      if  (0!=strncmp(pdire->d_name, "nittei.au", 8)) /*ǡե*/
	cnt++;
    pdire=readdir(dir);
  }
  if (0==cnt){
    closedir(dir);
    return;
  }  
  rewinddir(dir);

  str = (String *) XtCalloc(sizeof(String *), cnt);

  if (4 != kikan){    /*Ǥʤ*/
    daytime_get(&yy, &mm, &dd, &ji, &fun, &byou);
    switch(kikan){
    case 1:           /*3*/
      mm-=3;
      break;
    case 2:           /*6*/
      mm-=6;
      break;
    case 3:           /*ǯ*/
      yy--;
      break;
    } 
    if (1>mm){
      mm+=12;
      yy--;
    }
    sprintf(cs, "nit%04d%02d00", yy, mm);
  }else
    strcpy(cs, "nit00000000");
    
  i=0;
  pdire=readdir(dir);
  while(pdire){
    if (0 == strncmp(pdire->d_name, "nit", 3)){
      if  (0!=strncmp(pdire->d_name, "nittei.au", 8)){  /*ǡե*/
	if (0 > strncmp(cs, pdire->d_name, 11)){   /*ָ*/
	  if (NULL!=(fp=fopen(pdire->d_name, "r"))){
	    while (fgets(buff, MAX_BUFF, fp)){
	      if (ss){
		if (strstr(buff, ss)){              /**/
		  str[i++]=XtNewString(&(pdire->d_name[3]));
		  break;
		}
	      }else{
		str[i++]=XtNewString(&(pdire->d_name[3]));
		break;
	      }  
	    }/*while*/
	    fclose(fp);  
	  }/*open*/  
	}/**/  
      }/*nittei.au*/  
    }/*nit*/
    pdire=readdir(dir);
  }
  closedir(dir);
   
  if (0==i){
    select_ok=0;
    str[i++]=XtNewString("ʤ");
  }else
    select_ok=1;

  list_clear(list);
  qsort(str, i, sizeof(String), (int (*)(_Xconst void *, _Xconst void *)) sort_cmp);
  XawListChange(list, str, i, 0, True);
  
  if ((sb = XtNameToWidget(vport, "vertical")) != None) {
    XawScrollbarSetThumb(sb, top, -1.0);
    XtCallCallbacks(sb, XtNjumpProc, (XtPointer) & top);
  }

  if (select_ok){                          /*ȯɽ*/
    sprintf(wk, "nit%s", str[0]);
    XtSetArg(arglist[0], XtNstring, wk);
    XtSetArg(arglist[1], XtNtype, XawAsciiFile);  
    XtSetValues(s_edit, arglist, 2);
  }
}

/** ꥹ ***********************************************/
/**                                                        **/
void s_list_cb(Widget bar, XtPointer argArg, XtPointer itemArg)
{
  char wk[50];
  Arg arglist[10];
  XawListReturnStruct *item;

  if (!select_ok)
    return;

  item=(XawListReturnStruct *)itemArg;
  sprintf(wk, "nit%s", item->string);
  XtSetArg(arglist[0], XtNstring, wk);
  XtSetArg(arglist[1], XtNtype, XawAsciiFile);  
  XtSetValues(s_edit, arglist, 2);
}
