/***************************************************/
/* Copyright (C) 1999 Yoneji Seto */
/* nittei ץ*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <signal.h>
#include <unistd.h>
#include <sys/types.h>
#include <fcntl.h>
#include <dirent.h>
#include <sys/dir.h>
#include <sys/stat.h>
#include <sys/time.h>

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/AsciiText.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Command.h>
#include "nittei.h"

extern Display *dsp;
extern Widget top, top2, edit_widget;
extern char *edit_fname;
extern int m_max[13];
extern int h_day_max;
extern H_DAY h_day[365];

static int h_day_chk(int yy, int mm, int dd, char *h_name, int *furikae);
static void temp_create(int yy, int mm, int dd);
static void ichiran_create(int yy, int mm, int dd, char *ofname);
static void ichiran_close_cb(Widget w, XtPointer w1, XtPointer w2);

#define ICHIRAN_TEMP_FILE "ichiran_temp_file"


/** ɽ **********************************************/
/**                                                       **/
void ichiran_disp(int yy, int mm, int dd)
{
  static Atom wm_delete_window;

  Arg arglist[10];
  Widget paned, paned1, btn, ichiran_top;
  char ofname[50];

  sprintf(ofname, "ichiran%04d%02d", yy, mm);
  ichiran_create(yy, mm, dd, ofname);

  ichiran_top=XtVaCreatePopupShell("ichiran_window", topLevelShellWidgetClass, top, NULL);
  XtOverrideTranslations(ichiran_top, XtParseTranslationTable ("<Message>WM_PROTOCOLS: ichiran_close()"));

  paned = XtVaCreateManagedWidget("ichiran_paned", panedWidgetClass, ichiran_top, NULL);
  btn=XtVaCreateManagedWidget("ichiran_close", commandWidgetClass, paned, NULL);
  paned1 = XtVaCreateManagedWidget("ichiran_paned1", panedWidgetClass, paned, NULL);
  XtAddCallback(btn, XtNcallback, ichiran_close_cb, (XtPointer)ichiran_top);

  XtSetArg(arglist[0], XtNeditType, XawtextRead);
  XtSetArg(arglist[1], XtNtype, XawAsciiFile);  
  XtSetArg(arglist[2], XtNstring, ofname);
  XtCreateManagedWidget("ichiran_view", asciiTextWidgetClass, paned1, arglist, 3);

  XtRealizeWidget(ichiran_top);
  XtPopup(ichiran_top, XtGrabNone);

  wm_delete_window = XInternAtom(XtDisplay(ichiran_top), "WM_DELETE_WINDOW", False);
  XSetWMProtocols (XtDisplay(ichiran_top), XtWindow(ichiran_top), &wm_delete_window, 1);
}

/** ͽɽ  ܥ *********************************/
/**                                                       **/
void ichiran_close_cb(Widget w, XtPointer w1, XtPointer w2)
{
  XtDestroyWidget((Widget)w1);
}

/** ͽɽ  ****************************************/
/**                                                       **/
void ichiran_close(Widget w)
{
  XtDestroyWidget(w);
}

/** ͽɽ **********************************************/
/**                                                       **/
void ichiran_create(int yy, int mm, int dd, char *ofname)
{
  static char *youbi[7]={"","ʷ","ʲС","ʿ","ڡ","ʶ","ڡ"};

  char  mmdd[50], title[50], wk[H_NAME_MAX+50], h_name[H_NAME_MAX];
  FILE *fp, *ofp;
  int i, b, n, yno, h_fg, h_furikae;
  int furikae, ch;

  data_save();

  h_furikae=0;
  if (NULL==(ofp=fopen(ofname, "w")))
    return;
  sprintf(title, "======= %4dǯ%02d ͽɽ =======\n\n", yy, mm);
  fputs(title, ofp);

  for (i=1; i<=m_max[mm]; i++){
    temp_create(yy, mm, i);
    yno=youbi_cal(yy, mm, i);
    fputs("--------------------------------\n", ofp);
    sprintf(mmdd, "%2d%s ", i, youbi[yno]);
    h_fg=h_day_chk(yy, mm, i, h_name, &furikae);
    fputs(mmdd, ofp);
    if (h_fg){                           /*̾*/
      sprintf(wk, "%s", h_name);
      if (strlen(wk)>0)
	wk[strlen(wk)-1]='\0';
      fputs(wk, ofp);
    }
    if (h_furikae)                      /*ص*/
      fputs("ص", ofp);
    fputs("\n--------------------------------\n ", ofp);

    if (0==yno && h_fg && furikae)      /*صϿ*/
      h_furikae=1;
    else
      h_furikae=0;

    if (NULL==(fp=fopen(ICHIRAN_TEMP_FILE, "r")))
      fputs("\n", ofp);
    else{
      b=0;
      n=0;
      while(EOF!=(ch=fgetc(fp))){
	if (ch=='\n'){
	  fputs("\n ", ofp);
	  n=-1; b=0;
	}else if (ch=='(' && 0==n){
	  b=1;
	}else if (ch==')' && b){
	  fputs("ʬ", ofp);
	  b=0;
	}else if (ch==':' && b){
	  fputs("", ofp);
	}else
	  putc(ch, ofp);
	n++;
      }
      fclose(fp);
    }  
    fputs("\n\n", ofp);
  }  
  fclose(ofp);
}

/**  *********************************************/
/** ret 1= 0=ʿ                                   **/
int h_day_chk(int yy, int mm, int dd, char *h_name, int *furikae)
{
  int j;

  for (j=0; j<h_day_max; j++){
    if (0 == h_day[j].yy || yy == h_day[j].yy){
      if (mm == h_day[j].mm && dd == h_day[j].dd){
	strncpy(h_name, h_day[j].name, H_NAME_MAX);
        *furikae=h_day[j].furikae;
	return 1;
      }	
    }
  }

  return 0;
}

/** ƥݥ꡼˷ ***************************************/
/**                                                       **/
void temp_create(int yy, int mm, int dd)
{
  FILE *fp, *ofp;
  char fname[100];
  int  y_no, ch;
  struct stat st;

  if (NULL==(ofp=fopen(ICHIRAN_TEMP_FILE, "w")))
    return;

  /******/
  sprintf(fname, "nit%04d%02d%02d", yy, mm, dd);
  stat(fname, &st);
  if (NULL!=(fp=fopen(fname, "r"))){
    while (EOF!=(ch=fgetc(fp)))
      putc(ch, ofp);
    fclose(fp);  
  }

  /***η֤***/
  stat(D_DATA_FILE, &st);
  if (st.st_size){
    fputs("\n****\n", ofp);
    if (NULL!=(fp=fopen(D_DATA_FILE, "r"))){
      while (EOF!=(ch=fgetc(fp)))
	putc(ch, ofp);
      fclose(fp);  
    }
  }  
  
  /***轵,Ʊͽ***/
  y_no=youbi_cal(yy, mm, dd);
  sprintf(fname, "%s-%d", W_DATA_FILE, y_no);
  stat(fname, &st);
  if (st.st_size){
    fputs("\n**轵**\n", ofp);
    if (NULL!=(fp=fopen(fname, "r"))){
      while (EOF!=(ch=fgetc(fp)))
	putc(ch, ofp);
      fclose(fp);  
    }
  }

  /***,Ʊͽ***/
  sprintf(fname, "%s-%d", M_DATA_FILE, dd);
  stat(fname, &st);
  if (st.st_size){
    fputs("\n****\n", ofp);
    if (NULL!=(fp=fopen(fname, "r"))){
      while (EOF!=(ch=fgetc(fp)))
	putc(ch, ofp);
      fclose(fp);  
    }
  }

  fclose(ofp);
}
