/***************************************************/
/* Copyright (C) 1999 Yoneji Seto */
/* nittei ᥤ ץ*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <signal.h>
#include <unistd.h>
#include <sys/types.h>
#include <fcntl.h>
#include <dirent.h>
#include <sys/dir.h>
#include <sys/stat.h>
//#include <sys/time.h>
#include <time.h>

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/AsciiText.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Command.h>
#include "nittei.h"

XtAppContext app;
Display *dsp;
Widget top, label_yymmdd, label_hhmmss,  day_w[50], day_w_save;
int day_no[50];
int  yy_save, mm_save, dd_save, max_no;
int h_day_max, h_day_max_save;

int m_max[13]={0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};

H_DAY h_day[365];
			  
static void yymmdd_disp(int yy, int mm, int dd);
static void day_disp(int yy, int mm, int dd);
static void uruu_set(int yy);
static void time_up(XtPointer cl, XtIntervalId *iid);

static void hon_jitu_cb();
static void holiday_read(char *fname);
static void syunbun_syuubun(int yy);
static void syukujitu_hou(int yy);
static void size0_del(void);

/**************************************************************/
/** ᥤ                                                    **/
int main(int argc, char **argv)
{
  int    lyy,lmm;
  int    ji, fun, byou, i;
  char   *homedir;
  char   nittei_dir[1024], hfile[1024], fname[256];

  if(argc!=3){
    fprintf(stderr,"Usage : %s (yyyy) (mm)\n",argv[0]);
    return 1;
  }

  if(argc==3){
    lyy=atoi(argv[1]);
    lmm=atoi(argv[2]);
  }

  fprintf(stderr,"Create HTML file for %d/%d\n",lyy,lmm);
  homedir=getenv("HOME");

  daytime_get(&yy_save, &mm_save, &dd_save, &ji, &fun, &byou);
  
  strncpy(nittei_dir, homedir, sizeof(nittei_dir)-50);
  strcat(nittei_dir, "/NITTEI_DIR");
  mkdir(nittei_dir, 0700);
  chdir(nittei_dir);
  mkdir("HTML", 0700);
  size0_del();             /*0ä*/
  if (access(D_DATA_FILE, F_OK) != 0)
    creat(D_DATA_FILE, 0600);

  for (i=0; i<7; i++){
    sprintf(fname, "%s-%d", W_DATA_FILE, i);
    if (access(fname, F_OK) != 0)
      creat(fname, 0600);
  }

  for (i=1; i<32; i++){
    sprintf(fname, "%s-%d", M_DATA_FILE, i);
    if (access(fname, F_OK) != 0)
      creat(fname, 0600);
  }


#if 0
  h_day_max=0;
  if (1==argc){                         /*ե*/
    strncpy(hfile, homedir, sizeof(hfile)-50);
    strcat(hfile, "/nit_holiday");
    holiday_read(hfile);
  }else{
    for (i=1; i<argc; i++)
      holiday_read(argv[i]);
  }  
  h_day_max_save=h_day_max;      /*Υեɤ߹ʬκǸ*/
#endif

/*ե*/
  h_day_max=0;
  strncpy(hfile, homedir, sizeof(hfile)-50);
  strcat(hfile, "/nit_holiday");
  holiday_read(hfile);

  h_day_max_save=h_day_max;      /*Υեɤ߹ʬκǸ*/

  syunbun_syuubun(lyy);       /*ʬ ʬ*/
  syukujitu_hou(lyy);         /*ˡ*/
  uruu_set(lyy);              /*ǯ*/

  html_create(lyy, lmm, 1);

  return 0;
}

/** ǯɽ **********************************************/
/**                                                       **/
void yymmdd_disp(int yy, int mm, int dd)
{
  Arg arglist[10];
  char ws[50];

  sprintf(ws, "%4dǯ %2d %2d", yy, mm, dd);
  XtSetArg(arglist[0], XtNlabel, ws);
  XtSetValues(label_yymmdd, arglist, 1);
  XFlush(dsp);
}


/** ɽ ************************************************/
/**                                                       **/
void day_disp(int yy, int mm, int dd)
{
  Arg arglist[10];
  int    i, j, yno, no;
  char   lname[50];
  XtArgVal bg;
  XColor red, green, blue, cyan, xcw;
  Colormap cm;

  XtVaGetValues(top, XtNbackground, &bg, NULL);
  cm=DefaultColormap(dsp, 0);
  XAllocNamedColor(dsp, cm, "red", &red, &xcw);
  XAllocNamedColor(dsp, cm, "green", &green, &xcw);
  XAllocNamedColor(dsp, cm, "blue", &blue, &xcw);
  cyan.red=0L;
  cyan.green=65535L;
  cyan.blue=65535L;
  XAllocColor(dsp, cm, &cyan);

  for (i=1; i<max_no; i++){                 /**/
    if (i==1 || i==8 || i==15 || i==22 || i==29 || i==36)
      XtSetArg(arglist[0], XtNforeground, red.pixel);
    else if (i==7 || i==14 || i==21 || i==28 || i==35 || i==42)
      XtSetArg(arglist[0], XtNforeground, blue.pixel);
    else
      XtSetArg(arglist[0], XtNforeground, BlackPixel(dsp, 0));
    XtSetValues(day_w[i], arglist, 1);
  }

  for (i=0; i<50; i++)       /* ä*/
    day_no[i]=0;

  h_day_max=h_day_max_save;  /*եʬκǸ˥å*/
  syunbun_syuubun(yy);       /*ʬ ʬ*/
  syukujitu_hou(yy);         /*ˡ*/

  uruu_set(yy);              /*ǯ*/

  yno=youbi_cal(yy, mm, 1);    /*Ϥ*/

  XtSetArg(arglist[0], XtNmappedWhenManaged, False);
  no=1;
  for (i=0; i<yno; i++){                 /*ϤޤǤɽ*/
    XtSetArg(arglist[1], XtNlabel, "   ");
    XtSetValues(day_w[no], arglist, 2);
    no++;
  } 

  XtSetArg(arglist[0], XtNmappedWhenManaged, True);
  for (i=yno; i<7; i++){                /*դɽ ǽν*/
    sprintf(lname, "%3d", no-yno);
    XtSetArg(arglist[1], XtNlabel, lname);
    if (dd==no-yno)
      XtSetArg(arglist[2], XtNbackground, green.pixel);
    else
      XtSetArg(arglist[2], XtNbackground,  bg);
    XtSetValues(day_w[no], arglist, 3);
    day_no[no]=no-yno;
    no++;
  }

  for (i=0; i<5; i++){                     /*2ܰʹ*/
    for (j=0; j<7; j++){
      if (no-yno > m_max[mm])
	XtSetArg(arglist[0], XtNmappedWhenManaged, False);
      else
	XtSetArg(arglist[0], XtNmappedWhenManaged, True);
      sprintf(lname, "%3d", no-yno);
      XtSetArg(arglist[1], XtNlabel, lname);
      if (dd==no-yno)                               /**/
	XtSetArg(arglist[2], XtNbackground, green.pixel);
      else
	XtSetArg(arglist[2], XtNbackground,  bg);

      XtSetValues(day_w[no], arglist, 3);
      day_no[no]=no-yno;
      no++;
    }  
  }

  for (i=1; i<max_no; i++){                  /**/
    if (day_no[i]){
      for (j=0; j<h_day_max; j++){
	if (0 == h_day[j].yy || yy == h_day[j].yy){
	  if (mm == h_day[j].mm){
	    if (day_no[i] == h_day[j].dd){
	      XtSetArg(arglist[0], XtNforeground, red.pixel);
	      if (i==1 || i==8 || i==15 || i==22 || i==29 || i==36){  /*ص*/
                if (h_day[j].furikae)                    /*1=ؤƤ⤤*/
		  XtSetValues(day_w[i+1], arglist, 1);
	      }else  
		XtSetValues(day_w[i], arglist, 1);
	    }
	  }
	}
      }
    }
  }  

  day_w_save=day_w[dd+yno];          /*Widget¸*/

  XFlush(dsp);
}



/** եܥ  *****************************************/
/**                                                       **/
void day_up_down(viod)
{ 
  extern Widget top2;

  Arg arglist[10];
  XtArgVal bg;
  XColor red, green, xcw;
  Colormap cm;
  int yno;

  uruu_set(yy_save);              /*ǯ*/
  yno=youbi_cal(yy_save, mm_save, 1);    /*Ϥ*/

  XtVaGetValues(top, XtNbackground, &bg, NULL);
  cm=DefaultColormap(dsp, 0);
  XAllocNamedColor(dsp, cm, "red", &red, &xcw);
  XAllocNamedColor(dsp, cm, "green", &green, &xcw);
  
  XtSetArg(arglist[0], XtNbackground,  bg);
  XtSetValues(day_w_save, arglist, 1);
  XtSetArg(arglist[0], XtNbackground,  green.pixel);
  XtSetValues(day_w[dd_save + yno], arglist, 1);
  day_w_save=day_w[dd_save + yno];
  yymmdd_disp(yy_save, mm_save, dd_save);

  if (top2)
    edit_dat_chg(yy_save, mm_save, dd_save);
}


/**  ***************************************************/
/**                                                       **/
void hon_jitu_cb()
{
  int ji, fun, byou;

  daytime_get(&yy_save, &mm_save, &dd_save, &ji, &fun, &byou);
  day_disp_chg();
}

/** ܥˤդι ***********************************/
/**                                                       **/
void day_disp_chg(void)
{
  extern Widget top2;

  yymmdd_disp(yy_save, mm_save, dd_save);
  day_disp(yy_save, mm_save, dd_save);
  if (top2)
    edit_dat_chg(yy_save, mm_save, dd_save);
}

/**  ********************************************/
/**                                                       **/
int youbi_cal(int yy, int mm, int dd)
{
  int w, a;

  if (mm<3){
    yy--;
    mm+=12;
  }
  if ( ( yy > 1752 ) || ( ( yy == 1752 ) && ( mm >= 10 ) ) ) {
    /* 쥴ꥪ */
    a=(int)(1.25*yy)-(int)(yy/100)+(int)(yy/400)+(int)(2.6*mm+1.6)+dd;
  } else {
    /* ꥦ */
    a=(int)(1.25*yy)+(int)(2.6*mm+1.6)+dd + 5;
  }
  w=a % 7;
  return w;
}
 
/** ǯ򥻥å ********************************************/
/**                                                       **/
void uruu_set(int yy)
{
  m_max[2]=28;
  m_max[9] = (yy==1752) ? 19 : 30; /* 쥴ꥪȥꥦ³ */
  if ( yy >= 1752 ) {
    /* 쥴ꥪ */
    if ((yy % 100)==0 && (yy % 400)!=0)
      return;
    if ((yy % 4)==0)
      m_max[2]=29;
  } else {
    /* ꥦ */
    if ((yy % 4)==0)
      m_max[2]=29;
  }
}
    
/** 顼ॷʥ ɽ *******************************/
/**                                                       **/
void time_up(XtPointer cl, XtIntervalId *iid)
{
  extern Widget top2;

  static int old_fun=-1;

  Arg arglist[10];
  char   ws[50];
  int    yy, mm, dd, ji, fun, byou;
  div_t  dr;

  daytime_get(&yy, &mm, &dd, &ji, &fun, &byou);
  sprintf(ws, "%2d %2dʬ %2d", ji, fun, byou);
  XtSetArg(arglist[0], XtNlabel, ws);
  XtSetValues(label_hhmmss, arglist, 1);
  dr=div(fun, 10);                         /*塼Ǥʤ*/
  if (NULL==top2 && 0==dr.rem && 0==byou)  /*10ʬ˰᤹*/
    hon_jitu_cb();

  XFlush(dsp);

  if (old_fun != fun){
    time_chk(yy, mm, dd, ji, fun, byou);
    old_fun=fun;
  }

  XtAppAddTimeOut(app, 1000, &time_up, NULL);
}

/** ջΥå *****************************************/
/**                                                       **/
void daytime_get(int *yy, int *mm, int *dd, int *ji, int *fun, int *byou)
{
  struct timeval t;
  struct tm *tmp;

  gettimeofday(&t, NULL);
  tmp=localtime((time_t *)&t.tv_sec);
  *yy=tmp->tm_year + 1900;
  *mm=tmp->tm_mon + 1;
  *dd=tmp->tm_mday;
  *ji=tmp->tm_hour;
  *fun=tmp->tm_min;
  *byou=tmp->tm_sec;
}


/** եɤ߹ ***********************************/
/**                                                       **/
void holiday_read(char *fname)
{
  FILE *fp;
  char buff[H_NAME_MAX+30];
  char *dt;

  if (NULL==(fp=fopen(fname, "r"))){
    fprintf(stderr,"Failed to read nit_holiday\n");
    return;
  }
  while(NULL!=fgets(buff, H_NAME_MAX+30, fp)){
    dt=strtok(buff, ",");
    h_day[h_day_max].yy=atoi(dt);
    dt=strtok(NULL, ",");
    h_day[h_day_max].mm=atoi(dt);
    dt=strtok(NULL, ",");
    h_day[h_day_max].dd=atoi(dt);
    dt=strtok(NULL, ",");
    strncpy(h_day[h_day_max].name, dt, H_NAME_MAX);
    h_day[h_day_max].furikae=1;
    dt=strtok(NULL, ",");
    if (dt){
      if (dt[0]=='n')                 /*ؤʤ*/
	h_day[h_day_max].furikae=0;
    }  
    h_day_max++;
  }
  fclose(fp);
}

/** ʬȽʬ׻ ***************************************/
/**                                                     **/
void syunbun_syuubun(int yy)
{
  int d1, d2;

  d1=(int)(20.8431+0.242194*(yy-1980)-(int)((yy-1980)/4));   /*ʬ*/
  d2=(int)(23.2488+0.242194*(yy-1980)-(int)((yy-1980)/4));     /*ʬ*/
  h_day[h_day_max].yy=0;
  h_day[h_day_max].mm=3;
  h_day[h_day_max].dd=d1;
  h_day[h_day_max].furikae=1;
  strncpy(h_day[h_day_max].name, "ʬ\n", H_NAME_MAX);
  h_day_max++;
  h_day[h_day_max].yy=0;
  h_day[h_day_max].mm=9;
  h_day[h_day_max].dd=d2;
  h_day[h_day_max].furikae=1;
  strncpy(h_day[h_day_max].name, "ʬ\n", H_NAME_MAX);
  h_day_max++;
}

/** 2000 ǯʹ ˲ˡ б **************************/
/** 2003 ǯʹ ˲ˡ б **************************/
/**                                                      **/
void syukujitu_hou(int yy)
{
  int dd, yo, fg;

/*2000ǯϤ٤Ƹ*/
  if (2000 > yy){  
    h_day[h_day_max].yy=0;
    h_day[h_day_max].mm=1;
    h_day[h_day_max].dd=15;
    h_day[h_day_max].furikae=1;
    strncpy(h_day[h_day_max].name, "ͤ\n", H_NAME_MAX);
    h_day_max++;
    h_day[h_day_max].yy=0;
    h_day[h_day_max].mm=10;
    h_day[h_day_max].dd=10;
    h_day[h_day_max].furikae=1;
    strncpy(h_day[h_day_max].name, "ΰ\n", H_NAME_MAX);
    h_day_max++;
    h_day[h_day_max].yy=0;
    h_day[h_day_max].mm=7;
    h_day[h_day_max].dd=20;
    h_day[h_day_max].furikae=1;
    strncpy(h_day[h_day_max].name, "\n", H_NAME_MAX);
    h_day_max++;
    h_day[h_day_max].yy=0;
    h_day[h_day_max].mm=9;
    h_day[h_day_max].dd=15;
    h_day[h_day_max].furikae=1;
    strncpy(h_day[h_day_max].name, "Ϸ\n", H_NAME_MAX);
    h_day_max++;
    return;
  }

/*2000-2002ǯϳȷϷ*/
  if (2003 > yy){  
    h_day[h_day_max].yy=0;
    h_day[h_day_max].mm=7;
    h_day[h_day_max].dd=20;
    h_day[h_day_max].furikae=1;
    strncpy(h_day[h_day_max].name, "\n", H_NAME_MAX);
    h_day_max++;
    h_day[h_day_max].yy=0;
    h_day[h_day_max].mm=9;
    h_day[h_day_max].dd=15;
    h_day[h_day_max].furikae=1;
    strncpy(h_day[h_day_max].name, "Ϸ\n", H_NAME_MAX);
    h_day_max++;
    fg=0;
    for (dd=1; dd<15; dd++){
      yo=youbi_cal(yy, 1, dd);
      if (1==yo){
	fg++;
	if (2==fg){
	  h_day[h_day_max].yy=yy;
	  h_day[h_day_max].mm=1;
	  h_day[h_day_max].dd=dd;
	  h_day[h_day_max].furikae=0;
	  strncpy(h_day[h_day_max].name, "ͤ\n", H_NAME_MAX);
	  h_day_max++;
	  break;
	}
      }  
    }
    fg=0;
    for (dd=1; dd<15; dd++){
      yo=youbi_cal(yy, 10, dd);
      if (1==yo){
	fg++;
	if (2==fg){
	  h_day[h_day_max].yy=yy;
	  h_day[h_day_max].mm=10;
	  h_day[h_day_max].dd=dd;
	  h_day[h_day_max].furikae=0;
	  strncpy(h_day[h_day_max].name, "ΰ\n", H_NAME_MAX);
	  h_day_max++;
	  break;
	}
      }
    }
    return;
  }

  /* 2003ǯʹߤư */  
  fg=0;
  for (dd=1; dd<15; dd++){
    yo=youbi_cal(yy, 1, dd);
    if (1==yo){
      fg++;
      if (2==fg){
	h_day[h_day_max].yy=yy;
	h_day[h_day_max].mm=1;
	h_day[h_day_max].dd=dd;
	h_day[h_day_max].furikae=0;
	strncpy(h_day[h_day_max].name, "ͤ\n", H_NAME_MAX);
	h_day_max++;
        break;
      }
    }  
  }

  fg=0;
  for (dd=1; dd<15; dd++){
    yo=youbi_cal(yy, 10, dd);
    if (1==yo){
      fg++;
      if (2==fg){
	h_day[h_day_max].yy=yy;
	h_day[h_day_max].mm=10;
	h_day[h_day_max].dd=dd;
	h_day[h_day_max].furikae=0;
	strncpy(h_day[h_day_max].name, "ΰ\n", H_NAME_MAX);
	h_day_max++;
        break;
      }
    }
  }

  fg=0;
  for (dd=1; dd<22; dd++){
    yo=youbi_cal(yy, 7, dd);
    if (1==yo){
      fg++;
      if (3==fg){
	h_day[h_day_max].yy=yy;
	h_day[h_day_max].mm=7;
	h_day[h_day_max].dd=dd;
	h_day[h_day_max].furikae=0;
	strncpy(h_day[h_day_max].name, "\n", H_NAME_MAX);
	h_day_max++;
        break;
      }
    }
  }

  fg=0;
  for (dd=1; dd<22; dd++){
    yo=youbi_cal(yy, 9, dd);
    if (1==yo){
      fg++;
      if (3==fg){
	h_day[h_day_max].yy=yy;
	h_day[h_day_max].mm=9;
	h_day[h_day_max].dd=dd;
	h_day[h_day_max].furikae=0;
	strncpy(h_day[h_day_max].name, "Ϸ\n", H_NAME_MAX);
	h_day_max++;
        break;
      }
    }
  }
}

/** եκ ****************************************/
/**                                                      **/
void size0_del(void)
{
  DIR *dir;
  struct dirent *pdire;
  struct stat sbuf;
 
  dir=opendir(".");
  if (NULL==dir)
    return;
  pdire=readdir(dir);
  while(pdire){
    if (0 == strncmp(pdire->d_name, "nit", 3)){
      stat(pdire->d_name, &sbuf);
      if (0==sbuf.st_size)
	unlink(pdire->d_name);
    }
    pdire=readdir(dir);
  }
  closedir(dir);
}

/**  *********************************************/
/** ret 1= 0=ʿ                                   **/
int h_day_chk(int yy, int mm, int dd, char *h_name, int *furikae)
{
  int j;

  for (j=0; j<h_day_max; j++){
    if (0 == h_day[j].yy || yy == h_day[j].yy){
      if (mm == h_day[j].mm && dd == h_day[j].dd){
	strncpy(h_name, h_day[j].name, H_NAME_MAX);
        *furikae=h_day[j].furikae;
	return 1;
      }	
    }
  }

  return 0;
}

